<?php

namespace FM\Service;

use FM\Factory\Fm00000000CalendarioFactory;
use FM\Service\FuncionariosHierarqService;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class Fm00000000CalendarioService
{

    protected $CalendarioFactory;
    protected $FuncionariosHierarqService;
    protected $environment;
    protected $newCode;

    public function __construct(EntityManager $entityManager, Fm00000000CalendarioFactory $CalendarioFactory, FuncionariosHierarqService $FuncionariosHierarqService, Environment $environment, NewCode $newCode)
    {
        $this->connection                   = $entityManager->getConnection();
        $this->CalendarioFactory            = $CalendarioFactory;
        $this->FuncionariosHierarqService   = $FuncionariosHierarqService;
        $this->environment                  = $environment;
        $this->newCode                      = $newCode;
    }

    public function getTarefasCalendario($parametros)
    {
        $listaOperadores = $this->FuncionariosHierarqService->montarHierarquiaOperadores($this->environment->getCdOperador());

        return $this->CalendarioFactory->getTarefasCalendario(array(
            "PERIODOINICIAL"    => $parametros['PERIODOINICIAL'],
            "PERIODOFINAL"      => $parametros['PERIODOFINAL'],
            "NRLOCALCLIENTE"    => null,
            "NRLOCALCLIENTEPAI" => null,
            "NRATIVIDADE"       => null,
            "NRTIPOLOCALCLI"    => null
        ), $listaOperadores);
    }
}
